require 'spec_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to specify the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator.  If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails.  There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.
#
# Compared to earlier versions of this generator, there is very limited use of
# stubs and message expectations in this spec.  Stubs are only used when there
# is no simpler way to get a handle on the object needed for the example.
# Message expectations are only used when there is no simpler way to specify
# that an instance is receiving a specific message.

describe BikesController do

  # This should return the minimal set of attributes required to create a valid
  # Bike. As you add validations to Bike, be sure to
  # adjust the attributes here as well.
  let(:valid_attributes) { {  } }

  # This should return the minimal set of values that should be in the session
  # in order to pass any filters (e.g. authentication) defined in
  # BikesController. Be sure to keep this updated too.
  let(:valid_session) { {} }

  describe "GET index" do
    it "assigns all bikes as @bikes" do
      bike = Bike.create! valid_attributes
      get :index, {}, valid_session
      assigns(:bikes).should eq([bike])
    end
  end

  describe "GET show" do
    it "assigns the requested bike as @bike" do
      bike = Bike.create! valid_attributes
      get :show, {:id => bike.to_param}, valid_session
      assigns(:bike).should eq(bike)
    end
  end

  describe "GET new" do
    it "assigns a new bike as @bike" do
      get :new, {}, valid_session
      assigns(:bike).should be_a_new(Bike)
    end
  end

  describe "GET edit" do
    it "assigns the requested bike as @bike" do
      bike = Bike.create! valid_attributes
      get :edit, {:id => bike.to_param}, valid_session
      assigns(:bike).should eq(bike)
    end
  end

  describe "POST create" do
    describe "with valid params" do
      it "creates a new Bike" do
        expect {
          post :create, {:bike => valid_attributes}, valid_session
        }.to change(Bike, :count).by(1)
      end

      it "assigns a newly created bike as @bike" do
        post :create, {:bike => valid_attributes}, valid_session
        assigns(:bike).should be_a(Bike)
        assigns(:bike).should be_persisted
      end

      it "redirects to the created bike" do
        post :create, {:bike => valid_attributes}, valid_session
        response.should redirect_to(Bike.last)
      end
    end

    describe "with invalid params" do
      it "assigns a newly created but unsaved bike as @bike" do
        # Trigger the behavior that occurs when invalid params are submitted
        Bike.any_instance.stub(:save).and_return(false)
        post :create, {:bike => {  }}, valid_session
        assigns(:bike).should be_a_new(Bike)
      end

      it "re-renders the 'new' template" do
        # Trigger the behavior that occurs when invalid params are submitted
        Bike.any_instance.stub(:save).and_return(false)
        post :create, {:bike => {  }}, valid_session
        response.should render_template("new")
      end
    end
  end

  describe "PUT update" do
    describe "with valid params" do
      it "updates the requested bike" do
        bike = Bike.create! valid_attributes
        # Assuming there are no other bikes in the database, this
        # specifies that the Bike created on the previous line
        # receives the :update_attributes message with whatever params are
        # submitted in the request.
        Bike.any_instance.should_receive(:update).with({ "these" => "params" })
        put :update, {:id => bike.to_param, :bike => { "these" => "params" }}, valid_session
      end

      it "assigns the requested bike as @bike" do
        bike = Bike.create! valid_attributes
        put :update, {:id => bike.to_param, :bike => valid_attributes}, valid_session
        assigns(:bike).should eq(bike)
      end

      it "redirects to the bike" do
        bike = Bike.create! valid_attributes
        put :update, {:id => bike.to_param, :bike => valid_attributes}, valid_session
        response.should redirect_to(bike)
      end
    end

    describe "with invalid params" do
      it "assigns the bike as @bike" do
        bike = Bike.create! valid_attributes
        # Trigger the behavior that occurs when invalid params are submitted
        Bike.any_instance.stub(:save).and_return(false)
        put :update, {:id => bike.to_param, :bike => {  }}, valid_session
        assigns(:bike).should eq(bike)
      end

      it "re-renders the 'edit' template" do
        bike = Bike.create! valid_attributes
        # Trigger the behavior that occurs when invalid params are submitted
        Bike.any_instance.stub(:save).and_return(false)
        put :update, {:id => bike.to_param, :bike => {  }}, valid_session
        response.should render_template("edit")
      end
    end
  end

  describe "DELETE destroy" do
    it "destroys the requested bike" do
      bike = Bike.create! valid_attributes
      expect {
        delete :destroy, {:id => bike.to_param}, valid_session
      }.to change(Bike, :count).by(-1)
    end

    it "redirects to the bikes list" do
      bike = Bike.create! valid_attributes
      delete :destroy, {:id => bike.to_param}, valid_session
      response.should redirect_to(bikes_url)
    end
  end

end
